﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_bouncing_cats
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private List<ImageSprite> Sprites =
            new List<ImageSprite>();

        private void Form1_Load(object sender, EventArgs e)
        {
            Random rand = new Random();

            for (int i = 0; i < 10; i++)
            {
                float angle = rand.Next(-360, 360);
                float dangle = rand.Next(-180, 180);
                float scale = rand.Next(2, 5) / 20f;
                Bitmap bm = ResizeImage(Properties.Resources.cat, scale);
                float rx = bm.Width / 2f;
                float ry = bm.Height / 2f;
                PointF center = new PointF(
                    rand.Next((int)rx, picCanvas.ClientSize.Width - (int)rx),
                    rand.Next((int)ry, picCanvas.ClientSize.Height - (int)ry));
                float vx = rand.Next(10, 50);
                if (rand.Next(0, 2) == 1) vx = -vx;
                float vy = rand.Next(10, 50);
                if (rand.Next(0, 2) == 1) vy = -vy;
                PointF velocity = new PointF(vx, vy);

                Sprites.Add(new ImageSprite(angle, dangle, center, velocity, bm));                    
            }

            LastTime = DateTime.Now;
            tmrFrame.Enabled = true;
        }

        private Bitmap ResizeImage(Bitmap bm, float scale)
        {
            int width = (int)(bm.Width * scale);
            int height = (int)(bm.Height * scale);
            Bitmap result_bm = new Bitmap(width, height);
            using (Graphics gr = Graphics.FromImage(result_bm))
            {
                PointF[] dest_points =
                {
                    new PointF(0, 0),
                    new PointF(width, 0),
                    new PointF(0, height),
                };
                RectangleF src_rect = new RectangleF(
                    0, 0,
                    Properties.Resources.cat.Width,
                    Properties.Resources.cat.Height);
                gr.DrawImage(Properties.Resources.cat,
                    dest_points, src_rect, GraphicsUnit.Pixel);
            }
            return result_bm;
        }

        private void picCanvas_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.InterpolationMode = InterpolationMode.High;
            foreach (ImageSprite sprite in Sprites)
            {
                sprite.Draw(e.Graphics);
            }
        }

        private DateTime LastTime;

        private void tmrFrame_Tick(object sender, EventArgs e)
        {
            DateTime now = DateTime.Now;
            float elapsed = (float)(now - LastTime).TotalSeconds;

            foreach (ImageSprite sprite in Sprites)
            {
                sprite.Move(picCanvas.Bounds, elapsed);
            }
            LastTime = now;
            picCanvas.Refresh();
        }
    }
}
